<!-- <script lang="ts" setup>
import { useRouter } from 'vue-router';
import { useOrderStore } from "@/stores/order";

const orderStore = useOrderStore();
const router = useRouter();

const confirmPayment = () => {
    // ตรวจสอบว่าข้อมูลถูกกรอกครบทุกช่องแล้ว
    if (orderStore.creditcardnumber && orderStore.expirationdate && orderStore.name && orderStore.CVVnumber && orderStore.address) {
        // ทำการ redirect ไปยังหน้า confirmcreditpayment
        router.push('/confirmcreditpayment');
    } else {
        // แสดงข้อความเตือนให้กรอกข้อมูลให้ครบถ้วน
        alert('กรุณากรอกข้อมูลให้ครบถ้วน');
    }
};
</script> -->

<script setup lang="ts">
import { useRouter } from 'vue-router';
import { useOrderStore } from "@/stores/order";

const orderStore = useOrderStore();
const router = useRouter();

const confirmPayment = () => {
    // ตรวจสอบว่าข้อมูล credit card number ตรงกับ format ที่กำหนดหรือไม่
    const creditCardNumberRegex = /^\d{4} \d{4} \d{4} \d{4}$/;
    if (!creditCardNumberRegex.test(orderStore.creditcardnumber.toString())) {
        alert('กรุณากรอกเลขบัตรเครดิตให้ถูกต้อง');
        return;
    }
    // ตรวจสอบว่าข้อมูล expiration date ตรงกับ format ที่กำหนดหรือไม่
    const expirationDateRegex = /^\d{2}\/\d{2}$/;
    if (!expirationDateRegex.test(orderStore.expirationdate.toString())) {
        alert('กรุณากรอกวันหมดอายุให้ถูกต้อง');
        return;
    }

    // ตรวจสอบว่าข้อมูล CVV number ตรงกับ format ที่กำหนดหรือไม่
    const cvvNumberRegex = /^\d{3}$/;
    if (!cvvNumberRegex.test(orderStore.CVVnumber.toString())) {
        alert('กรุณากรอกเลข CVV ให้ถูกต้อง');
        return;
    }

    // ทำการ redirect ไปยังหน้า confirmcreditpayment
    router.push('/confirmcreditpayment');
};

</script>



<template>
    <v-container>
        <v-row class="mt-8">
            <v-col cols="5"></v-col>
            <v-col><span class="font">ข้อมูลบัตรเครดิต/เดบิต</span></v-col>
        </v-row>
        <v-row class="mt-16">
            <v-col cols="1"></v-col>
            <v-col cols="2"><span class="font">เลขบัตรเครดิต</span></v-col>
            <v-col>
                <v-text-field v-model="orderStore.creditcardnumber" class="custom-text-field"
                    label="0000 0000 0000 0000"
                    :rules="[v => !!v || 'เลขบัตรเครดิตห้ามว่าง',
                (v) => (v && /^\d{4} \d{4} \d{4} \d{4}$/.test(v)) || 'เลขบัตรเครดิต ต้องประกอบไปด้วยตัวเลข 16 หลัก ตามรูปแบบข้างต้น']"
                    v-mask="'#### #### #### ####'" masked persistent>
                </v-text-field>
            </v-col>
        </v-row>
        <v-row class="mt-10">
            <v-col cols="1"></v-col>
            <v-col cols="2"><span class="font">วันหมดอายุ</span></v-col>
            <v-col>
                <v-text-field v-model="orderStore.expirationdate" class="custom-text-field" label="00/00" :rules="[(v) => !!v || 'วันที่หมดอายุห้ามว่าง',
                (v) => (v && /^\d{2}\/\d{2}$/.test(v)) || 'วันหมดอายุ ต้องกรอกตามรูปแบบข้างต้น']" v-mask="'##/##'"
                    masked="true" :persistent="true">
                </v-text-field>
            </v-col>
        </v-row>
        <v-row class="mt-10">
            <v-col cols="1"></v-col>
            <v-col cols="2"><span class="font">ชื่อเจ้าของบัตร</span></v-col>
            <v-col><v-text-field v-model="orderStore.name" class="custom-text-field" label="*****"
                    :rules="[(v) => !!v || 'ชื่อเจ้าของบัตรห้ามว่าง',]"></v-text-field></v-col>
        </v-row>
        <v-row class="mt-10">
            <v-col cols="1"></v-col>
            <v-col cols="2"><span class="font">เลข CVV</span></v-col>
            <v-col>
                <v-text-field v-model="orderStore.CVVnumber" class="custom-text-field" label="000" :rules="[(v) => !!v || 'CVV ห้ามว่าง',
                (v) => (v && /^\d{3}$/.test(v)) || 'เเลข CVV ต้องประกอบไปด้วยตัวเลข 3 หลัก ตามรูปแบบข้างต้น']"
                    v-mask="'###'" masked="true" :persistent="true">
                </v-text-field>
            </v-col>
        </v-row>
        <v-row class="mt-10">
            <v-col cols="1"></v-col>
            <v-col cols="2"><span class="font">ที่อยู่</span></v-col>
            <v-col><v-text-field v-model="orderStore.address" class="custom-text-field"
                    :rules="[(v) => !!v || 'ที่อยู่ห้ามว่าง',]"></v-text-field></v-col>
        </v-row>
        <v-row class="mt-16">
            <v-col cols="10"></v-col>
            <v-col cols="1"><v-btn class="fontbtn" height="50px" to="/summaryproductsale">ยกเลิก</v-btn></v-col>
            <v-col cols="1">
                <!-- <v-btn class="fontbtn" height="50px" @click="confirmPayment ">ยืนยัน</v-btn> -->
                <v-btn class="fontbtn" height="50px" @click="confirmPayment(); orderStore.setImage()">ยืนยัน</v-btn>
            </v-col>
        </v-row>
    </v-container>
</template>



<style scoped>
.fontbtn {
    text-align-last: center;
    font-family: fantasy;
    font-size: 20px;
    color: black;
}

.font {
    text-align-last: center;
    font-family: fantasy;
    font-size: 30px;
    color: black;
}

.custom-text-field {
    width: 1000px;
    height: 50px;
}
</style>